// All credit to InnovativeEngineer on Instructables
// Check out his YouTube Channel @InnovativeEngineering
// If you have any questions, post them below the Instructable

#include <dht11.h>
#include <LiquidCrystal.h>
#define DHT11PIN A0
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

dht11 DHT11;

int desiredTemp = 65; // set desired temp in the middle of the range to start

const int upPin = 7; // button that increases the desired temp
const int downPin = 6; // button that decreases the desired temp

int upState = 0; // sets normal state of button to 0
int downState = 0; // sets normal state of button to 0



void setup()
{
  pinMode(upPin, INPUT_PULLUP); // INPUT_PULLUP is used b/c the button is connected to GND - this completely removes button bounce (fluctuation in the state of the button)
  pinMode(downPin, INPUT_PULLUP); // ^^^
  lcd.begin(16,2);
  Serial.begin(9600);
  lcd.print("Current Temp: ");
  lcd.setCursor(0,1);
  lcd.print("Set Temp: ");
}

void loop()
{
  changeDesiredTemp();
  lcd.setCursor(14,0);
  int chk = DHT11.read(DHT11PIN);
  int temp = (float)((DHT11.temperature * 1.8000) + 32);
  lcd.print(temp);
  lcd.setCursor(10,1);
  lcd.print(desiredTemp);
  lcd.setCursor(13,1);
  lcd.print("   "); // <<< VERY IMPORTANT - CLEARS MIN AND MAX FROM LCD SCREEN WHEN THE DESIRED TEMP IS NOT 55 OR 75
  if (desiredTemp == 75){
    lcd.setCursor(13,1);
    lcd.print("Max"); // shows that 75 is the max temp & creates a range (55-75) for the desired temp
  }
  if (desiredTemp == 55){
    lcd.setCursor(13,1);
    lcd.print("Min"); // shows that 55 is the min temp & creates a range (55-75) for the desired temp 
  }
  if (temp > desiredTemp){
    digitalWrite(8, LOW);
    digitalWrite(9, HIGH);
  }

  if (desiredTemp > temp){
    digitalWrite(8, HIGH);
    digitalWrite(9, LOW);
  }
} 

void changeDesiredTemp() {
  upState = digitalRead(upPin);
  downState = digitalRead(downPin);
  if(desiredTemp < 75){
    if (upState == LOW){
    desiredTemp += 1;
    delay(200); // to prevent one relatively quick tap of the button from making the desiredTemp increase rapidly
  }
 }
 if(desiredTemp > 55){
  if (downState == LOW){
    desiredTemp -= 1;
    delay(200); // to prevent one relatively quick tap of the button from making the desiredTemp decrease rapidly
  }
 }
  
}


